#if HAVE_DEMANGLE

#include <libiberty/demangle.h>

const char* ezt_demangle(const char* mangled_str) {
  /* todo: add an option to get only the function name */

  /* get the full function prototype (including parameters and return type)  */
  return cplus_demangle(mangled_str, DMGL_AUTO | DMGL_PARAMS);
}

#else  /* HAVE_DEMANGLE */

/* Libiberty is not available, return the mangled string */
const char* ezt_demangle(const char* mangled_str) {
  return mangled_str;
}

#endif	/* HAVE_DEMANGLE */
